//+------------------------------------------------------------------+
//|                                                         Pv-2.mq4 |
//|                                                          |
//|                                                Skype privalov-sv |
//+------------------------------------------------------------------+
#property copyright ""
#property link      "Skype privalov-sv"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 1
#property  indicator_color1  Silver
#property  indicator_width1  1

#import "#_lib_FFT.ex4"
void realfastfouriertransform(double& a[], int tnn, bool inversefft); 
#import
extern   int    n      = 5;    //  - 
extern   bool   h      = true;
//---- indicator buffers
double     Buffer1[];
//Global variables
int N;                  //N is number of data points.

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   N=MathPow(2,n);
   SetIndexStyle(0,DRAW_HISTOGRAM);
   IndicatorDigits(Digits+Digits);
//---- indicator buffers mapping
   SetIndexBuffer(0,Buffer1);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("Pv-42("+n+","+h+")");
//   SetIndexLabel(0,"amplitude");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
   double  porog;
   double data[],amplitude,hpase;
   ArrayResize(data,N-1);
  
//---- last counted bar will be recounted
   if (counted_bars==0)   limit=Bars-1; //    ,     
   if (counted_bars>0)   limit=Bars-counted_bars-1; //       
   //     
   for(int j=limit;j>=0;j--)
      {
      for(int i=0;i<N-1;i++) data[i]=Close[i];
      realfastfouriertransform(data,N,false);   //   CLOSE  
      amplitude=0; //  
      hpase=0;
      for(i=1;i<N/2;i++)
         {
         amplitude=amplitude+data[i*2];
         hpase=hpase+MathArctan(data[2*i+1]/data[2*i]);
         }
      if(h)Buffer1[j]=amplitude;else Buffer1[j]=hpase;//   
      }
   return(0);
  }
//+------------------------------------------------------------------+
//---------------------------------------------------------------------+